/* file QISH/lib/genqish.c */
/* emacs Time-stamp: <2003 Fe 12 Wed 18h03:08 cet {genqish.c} Basile STARYNKEVITCH@hector.lesours> */
/* prcsid $Id: genqish.c 1.12 Wed, 19 Feb 2003 10:56:23 +0100 basile $ */
/* prcsproj $ProjectHeader: Qish qish0.88 Sun, 23 Feb 2003 14:55:43 +0100 basile $ */
//  Copyright  2001 Basile STARYNKEVITCH

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#define _GNU_SOURCE
#include <stdlib.h>
#include <stddef.h>
#include <stdio.h>
#include <time.h>
#include <setjmp.h>
#include <string.h>
#include <unistd.h>



void first (int a);
void second (int *pa, int b, int c);


int
main (int argc, char **argv)
{
  char buf[500];
  char *pc = 0;
  time_t t = 0;
  int nbopen = 0;
  int nbmodule = 0;
  int nbfct = 0;
  t = time (0);
  puts ("#ifndef _QISHGEN_TIMESTAMP");
  memset (buf, 0, sizeof (buf));
  strncpy (buf, ctime (&t), sizeof (buf) - 1);
  pc = strchr (buf, '\n');
  if (pc)
    *pc = 0;
  puts ("/*** file _qishgen.h generated by genqish.c ** DO NOT EDIT **/");
  printf ("#define _QISHGEN_TIMESTAMP \"%s\"\n", buf);
  printf ("#define QISH_SETJMP_SIZE %d /*sizeof(jmp_buf) in bytes*/\n",
	  sizeof (jmp_buf));
  printf ("#define QISH_PAGESIZE %d\n", (int) sysconf (_SC_PAGE_SIZE));
  printf ("/* ARGMAX=%d */\n", (int) sysconf (_SC_ARG_MAX));
  printf ("/* STREAM_MAX=%d */\n", (int) sysconf (_SC_STREAM_MAX));
  nbopen = (int) sysconf (_SC_OPEN_MAX);
  printf ("#define QISH_OPEN_MAX %d\n", nbopen);
  nbmodule = (nbopen / 2 + 40) | 0xf;
  if (nbmodule < 64)
    nbmodule = 64;
  else if (nbmodule > 512)
    nbmodule = 512;
  printf ("#define QISH_MAX_MODULE %d\n", nbmodule);
  nbfct = ((48 * nbmodule) | 0x1f) + 1;
  if (nbfct > 65536)
    nbfct = 65536;
  printf ("#define QISH_MAX_FUNCTION %d\n", nbfct);
  memset (buf, 0, sizeof (buf));
  getcwd(buf, sizeof(buf));
  printf ("#define QISH_SRCDIR \"%s\"\n", buf);
  printf ("/* CHILD_MAX=%d */\n", (int) sysconf (_SC_CHILD_MAX));
  printf ("/* CLK_TCK=%d */\n", (int) sysconf (_SC_CLK_TCK));
  printf ("/* %d phys. pages=%dMbytes */\n",
	  (int)sysconf (_SC_PHYS_PAGES),
	  (int) ((sysconf (_SC_PHYS_PAGES) / 1024) * (sysconf (_SC_PAGE_SIZE) /
						      1024)));
  memset (buf, 0, sizeof (buf));
  gethostname (buf, sizeof (buf) - 1);
  printf ("/* host: %s */\n", buf);
  printf ("/* sizeof int:%d long:%d long long:%d double:%d ptr:%d funptr:%d wchar_t:%d */\n",
	  (int) sizeof (int), (int) sizeof (long), (int) sizeof (long long), (int) sizeof (double),
	  (int) sizeof (void *), (int) sizeof (void (*)()), sizeof(wchar_t));
  if ((int)sizeof(unsigned int) == (int)sizeof(void*))
    printf("typedef unsigned int qish_uaddr_t; /*%dbytes, same as void* */\n", (int)sizeof(void*));
  else if ((int)sizeof(unsigned long) == (int)sizeof(void*))
    printf("typedef unsigned long qish_uaddr_t; /*%dbytes, same as void* */\n", (int)sizeof(void*));
  else if ((int)sizeof(unsigned long long) == (int)sizeof(void*))
    printf("typedef unsigned long long qish_uaddr_t; /*%dbytes, same as void* */\n", (int)sizeof(void*));
  else {
    puts("#error genqish cannot typedef qish_uaddr_t");
    fprintf(stderr, "no unsigned type with same size %d as pointers!\n", (int)sizeof(void*));
    exit(1);
  }
  puts("typedef qish_uaddr_t qish_uword_t;\n");
  if ((int)sizeof(int) == (int)sizeof(void*))
    printf("typedef int qish_word_t; /*%dbytes, same as void* */\n", (int)sizeof(void*));
  else if ((int)sizeof(unsigned long) == (int)sizeof(void*))
    printf("typedef long qish_word_t; /*%dbytes, same as void* */\n", (int)sizeof(void*));
  else if ((int)sizeof(long long) == (int)sizeof(void*))
    printf("typedef long long qish_word_t; /*%dbytes, same as void* */\n", (int)sizeof(void*));
  else {
    puts("#error genqish cannot typedef qish_word_t");
    fprintf(stderr, "no signed type with same size %d as pointers!\n", (int)sizeof(void*));
    exit(1);
  }
  first (__LINE__);
  puts ("#endif /*_QISHGEN_TIMESTAMP*/");
  return 0;
}


void
first (int a)
{
  putchar ('\n');
  second (&a, a + 2, a + 3);
}

void
second (int *pa, int b, int c)
{
  int delta = &b - pa;
  printf ("/*pa=%p &b=%p &c=%p &delta=%p delta=%d*/\n",
	  (void*)pa, (void*)&b, (void*)&c, (void*)&delta, delta);
  if (delta > 0)
    puts ("#define QISH_STACK_UP 1 \n"
	  "#define QISH_STACK_DOWN 0\n");
  else
    puts ("#define QISH_STACK_DOWN 1 \n"
	  "#define QISH_STACK_UP 0\n");
  if (&c > &b)
    puts ("#define QISH_ARGS_UP 1\n"
	  "#define QISH_ARGS_DOWN 0\n");
  else
    puts ("#define QISH_ARGS_DOWN 1\n"
	  "#define QISH_ARGS_UP 0\n");

}

/* eof $Id: genqish.c 1.12 Wed, 19 Feb 2003 10:56:23 +0100 basile $ */
